/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui.FieldBasedUI.DownsizeUI;

import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import org.visnow.vn.gui.swingwrappers.UserActionListener;
import org.visnow.vn.gui.swingwrappers.UserEvent;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class DownsizeUI extends javax.swing.JPanel
{
    private DownsizeParams params = null;
    private boolean active = true;
    JSpinner[] spinners = {};
    JLabel[] spinnerLabels = {};
    /**
     * Creates new form DownsizeUI
     */
    public DownsizeUI()
    {
        initComponents();
        spinners = new JSpinner[]{iSpinner, jSpinner, kSpinner};
        spinnerLabels = new JLabel[]{iLabel, jLabel, kLabel};
        preferredNodeNumberSlider.addUserActionListener(new UserActionListener() {
            @Override
            public void userChangeAction(UserEvent event) {               
                updateSpinners();
            }

            @Override
            public void userAction(UserEvent event) {
            }
        });
        preferredNodeNumberSlider.setFireUserChangeOnMinMaxUpdate(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        modeSelectorPanel = new javax.swing.JPanel();
        randomButton = new javax.swing.JRadioButton();
        regularButton = new javax.swing.JRadioButton();
        minimalDownButton = new javax.swing.JButton();
        spinnerPanel = new javax.swing.JPanel();
        iLabel = new javax.swing.JLabel();
        iSpinner = new javax.swing.JSpinner();
        jLabel = new javax.swing.JLabel();
        jSpinner = new javax.swing.JSpinner();
        kLabel = new javax.swing.JLabel();
        kSpinner = new javax.swing.JSpinner();
        buttonsPanel = new javax.swing.JPanel();
        center = new javax.swing.JToggleButton();
        sliderPanel = new javax.swing.JPanel();
        preferredNodeNumberSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();

        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        setLayout(new java.awt.GridBagLayout());

        modeSelectorPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        modeSelectorPanel.setLayout(new java.awt.GridBagLayout());

        buttonGroup1.add(randomButton);
        randomButton.setText("random");
        randomButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                randomButtonActionPerformed(evt);
            }
        });
        modeSelectorPanel.add(randomButton, new java.awt.GridBagConstraints());

        buttonGroup1.add(regularButton);
        regularButton.setSelected(true);
        regularButton.setText("regular");
        regularButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regularButtonActionPerformed(evt);
            }
        });
        modeSelectorPanel.add(regularButton, new java.awt.GridBagConstraints());

        minimalDownButton.setText("minimal downsize");
        minimalDownButton.setToolTipText("<html>click this button to set downsized sample to maximum allowed size<p>\n(text glyphs admit by default 2000 glyphs, glyphs admit up to 100000 glyphs)<p>\nThis upper limit of sample size can be changed by editing <p>\nthe 'preferred sample size' slider upper bound field</html>\n");
        minimalDownButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        minimalDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                minimalDownButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        modeSelectorPanel.add(minimalDownButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(modeSelectorPanel, gridBagConstraints);

        spinnerPanel.setLayout(new java.awt.GridBagLayout());

        iLabel.setText("I");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        spinnerPanel.add(iLabel, gridBagConstraints);

        iSpinner.setModel(new javax.swing.SpinnerNumberModel(3, 1, null, 1));
        iSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                iSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        spinnerPanel.add(iSpinner, gridBagConstraints);

        jLabel.setText("j");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        spinnerPanel.add(jLabel, gridBagConstraints);

        jSpinner.setModel(new javax.swing.SpinnerNumberModel(3, 1, null, 1));
        jSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        spinnerPanel.add(jSpinner, gridBagConstraints);

        kLabel.setText("k");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        spinnerPanel.add(kLabel, gridBagConstraints);

        kSpinner.setModel(new javax.swing.SpinnerNumberModel(3, 1, null, 1));
        kSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                kSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        spinnerPanel.add(kSpinner, gridBagConstraints);

        buttonsPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        spinnerPanel.add(buttonsPanel, gridBagConstraints);

        center.setText("center");
        center.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        center.setMargin(new java.awt.Insets(2, 2, 2, 2));
        spinnerPanel.add(center, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(spinnerPanel, gridBagConstraints);

        sliderPanel.setLayout(new java.awt.BorderLayout());

        preferredNodeNumberSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        preferredNodeNumberSlider.setGlobalMin(1);
        preferredNodeNumberSlider.setMax(100000);
        preferredNodeNumberSlider.setMin(1);
        preferredNodeNumberSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        preferredNodeNumberSlider.setSubmitOnAdjusting(false);
        preferredNodeNumberSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("preferred sample size"));
        preferredNodeNumberSlider.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        preferredNodeNumberSlider.setToolTipText("<html>set preferred number of sample nodes<p>\nIf the sampled field is regular and 'regular' option is chosen, <p>\neffective sample  size can be slightly different.<p>\nNote: The slider upper bound value is used when <p>\nthe 'minimal downsize' button is clicked.</html>"); // NOI18N
        preferredNodeNumberSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                preferredNodeNumberSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        sliderPanel.add(preferredNodeNumberSlider, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(sliderPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void iSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_iSpinnerStateChanged
    {//GEN-HEADEREND:event_iSpinnerStateChanged
        if (params != null)
            params.getDown()[0] = (Integer)iSpinner.getValue();
        params.fireStateChanged();
    }//GEN-LAST:event_iSpinnerStateChanged

    private void jSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_jSpinnerStateChanged
    {//GEN-HEADEREND:event_jSpinnerStateChanged
        if (params != null)
            params.getDown()[1] = (Integer)jSpinner.getValue();   
        params.fireStateChanged();     
    }//GEN-LAST:event_jSpinnerStateChanged

    private void kSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_kSpinnerStateChanged
    {//GEN-HEADEREND:event_kSpinnerStateChanged
        if (params != null)
            params.getDown()[2] = (Integer)kSpinner.getValue(); 
        params.fireStateChanged();     
    }//GEN-LAST:event_kSpinnerStateChanged

    private void minimalDownButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_minimalDownButtonActionPerformed
    {           
        active = false;//GEN-HEADEREND:event_minimalDownButtonActionPerformed
        for (int i = 0; i < params.getnDims(); i++) {
            spinners[i].setModel(new SpinnerNumberModel(params.getMinDown()[i],
                                                        params.getMinDown()[i],
                                                        params.getMaxDown()[i], 1));
            params.getDown()[i] = params.getMinDown()[i];
        }
        active = true;
        params.fireStateChanged();     
    }//GEN-LAST:event_minimalDownButtonActionPerformed

    private void preferredNodeNumberSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_preferredNodeNumberSliderUserChangeAction
    {//GEN-HEADEREND:event_preferredNodeNumberSliderUserChangeAction
        params.setMaxSize(preferredNodeNumberSlider.getMax().longValue());
        if (!preferredNodeNumberSlider.isAdjusting())
            params.setPreferredSize((int)preferredNodeNumberSlider.getValue());
        params.fireStateChanged();  
    }//GEN-LAST:event_preferredNodeNumberSliderUserChangeAction

    private void randomButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_randomButtonActionPerformed
    {//GEN-HEADEREND:event_randomButtonActionPerformed
        setRandom(randomButton.isSelected());
    }//GEN-LAST:event_randomButtonActionPerformed

    private void regularButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_regularButtonActionPerformed
    {//GEN-HEADEREND:event_regularButtonActionPerformed
        setRandom(randomButton.isSelected());
    }//GEN-LAST:event_regularButtonActionPerformed

    private void setRandom(boolean random)
    {
        params.setRandom(random);
        center.setVisible(!random && params.getDown() != null);
        spinnerPanel.setVisible(!random);
        params.fireStateChanged();
    }
    
    public void setParams(DownsizeParams params)
    {
        this.params = params;
        params.setUI(this);
    }

    public void updateSpinners()
    {
        active = false;
        int nDim = params.getnDims();
        for (int i = 0; i < 3; i++) 
            if (i < nDim) {
                params.getDown()[i] = Math.max(params.getMinDown()[i], 
                                               Math.min(params.getMaxDown()[i], params.getDown()[i]));
                spinners[i].setModel(new SpinnerNumberModel(params.getDown()[i],
                                                            params.getMinDown()[i],
                                                            params.getMaxDown()[i], 1));
                spinners[i].setVisible(true);
                spinnerLabels[i].setVisible(true);
            }
            else {
                spinners[i].setVisible(false);
                spinnerLabels[i].setVisible(false);
            }
        active = true;
    }
    
    public void updateFromParams()
    {
        if (params == null)
            return;
        active = false;
        if (params.getDown() != null) 
            updateSpinners();
        modeSelectorPanel.setVisible(params.getDown() != null);
        spinnerPanel.setVisible(params.getDown() != null);
        preferredNodeNumberSlider.setAll(params.getMinSize(), 
                                         params.getMaxSize(),
                                         params.getPreferredSize());
        randomButton.setSelected(params.isRandom() || params.getDown() == null);
        center.setEnabled(!params.isRandom() && params.getDown() != null);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JToggleButton center;
    private javax.swing.JLabel iLabel;
    private javax.swing.JSpinner iSpinner;
    private javax.swing.JLabel jLabel;
    private javax.swing.JSpinner jSpinner;
    private javax.swing.JLabel kLabel;
    private javax.swing.JSpinner kSpinner;
    private javax.swing.JButton minimalDownButton;
    private javax.swing.JPanel modeSelectorPanel;
    private org.visnow.vn.gui.widgets.ExtendedSlider preferredNodeNumberSlider;
    private javax.swing.JRadioButton randomButton;
    private javax.swing.JRadioButton regularButton;
    private javax.swing.JPanel sliderPanel;
    private javax.swing.JPanel spinnerPanel;
    // End of variables declaration//GEN-END:variables

}
